diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java b/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
index 7ceaf568b..7399d2bd2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemIceSkates.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemIceSkates extends Item implements IArmorItem{
+public class ItemIceSkates extends Item implements IArmorItem<HumanArmorShape> {
     public ItemIceSkates(String translationKey, String namespaceId, int id) {
         super(translationKey, namespaceId, id);
         setMaxStackSize(1);
@@ -15,7 +18,7 @@ public class ItemIceSkates extends Item implements IArmorItem{
     }
 
     @Override
-    public int getArmorPiece() {
-        return PIECE_BOOTS;
+    public @NotNull HumanArmorShape getArmorShape() {
+        return HumanArmorShape.BOOTS;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index 34aa4b715..0aaedb7b0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
@@ -69,6 +70,17 @@ public class ItemJar extends ItemPlaceable {
                     }
                 }
                 
+                return itemstack;
+            } else if (entity instanceof MobButterfly) {
+                MobButterfly butterfly = (MobButterfly) entity;
+                MobButterfly.ButterflyEntry color = MobButterfly.colorEntries.get(butterfly.getColor());
+
+                boolean didFillJar = fillJar(entityplayer, new ItemStack(color.jarItem.get(), 1));
+
+                if(!world.isClientSide && didFillJar) {
+                    butterfly.remove();
+                }
+
                 return itemstack;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
index 130250496..9044fab12 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemQuiver extends Item implements IArmorItem
+public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape>
 {
 
     public ItemQuiver(String name, String namespaceId, int id)
@@ -100,7 +103,7 @@ public class ItemQuiver extends Item implements IArmorItem
 	}
 
 	@Override
-	public int getArmorPiece() {
-		return PIECE_CHEST;
+	public @NotNull HumanArmorShape getArmorShape() {
+		return HumanArmorShape.CHEST;
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
index 93874ca75..2d066f5cd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import org.jetbrains.annotations.NotNull;
 
-public class ItemQuiverEndless extends Item implements IArmorItem
+public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShape>
 {
 
     public ItemQuiverEndless(String name, String namespaceId, int id)
@@ -17,7 +19,8 @@ public class ItemQuiverEndless extends Item implements IArmorItem
     }
 
     @Override
-    public int getArmorPiece() {
-        return PIECE_CHEST;
+    public @NotNull HumanArmorShape getArmorShape() {
+        return HumanArmorShape.CHEST;
     }
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
new file mode 100644
index 000000000..67d5b3213
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class ItemStatue extends Item {
+	protected final Block<?> statueBlockBottom;
+	protected final Block<?> statueBlockTop;
+
+	public ItemStatue(String name, String namespaceId, int id, Block<?> statueBlockBottom, Block<?> statueBlockTop) {
+		super(name, namespaceId, id);
+		maxStackSize = 64;
+        this.statueBlockBottom = statueBlockBottom;
+        this.statueBlockTop = statueBlockTop;
+    }
+
+	@Override
+	public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+			blockX += side.getOffsetX();
+			blockY += side.getOffsetY();
+			blockZ += side.getOffsetZ();
+		}
+		if(!statueBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
+			return false;
+		}
+
+		world.noNeighborUpdate = true;
+		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, statueBlockBottom.id(), MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, statueBlockTop.id(), MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+		world.noNeighborUpdate = false;
+		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, statueBlockBottom.id());
+		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, statueBlockTop.id());
+		world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, statueBlockBottom, EnumBlockSoundEffectType.PLACE);
+		statueBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+		statueBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, player, xPlaced, yPlaced);
+		itemstack.consumeItem(player);
+		return true;
+	}
+
+	@Override
+	public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+			blockX += direction.getOffsetX();
+			blockY += direction.getOffsetY();
+			blockZ += direction.getOffsetZ();
+		}
+		if(!statueBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
+			return;
+		}
+
+		world.noNeighborUpdate = true;
+		world.setBlockWithNotify(blockX, blockY, blockZ, statueBlockBottom.id());
+		world.setBlockWithNotify(blockX, blockY + 1, blockZ, statueBlockTop.id());
+		world.noNeighborUpdate = false;
+		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, statueBlockBottom.id());
+		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, statueBlockTop.id());
+		world.playBlockSoundEffect(null, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, statueBlockBottom, EnumBlockSoundEffectType.PLACE);
+		statueBlockBottom.onBlockPlacedOnSide(world, blockX, blockY, blockZ, direction.getSide(), 0.5, 0.5);
+		statueBlockTop.onBlockPlacedOnSide(world, blockX, blockY + 1, blockZ, direction.getSide(), 0.5, 0.5);
+		itemStack.consumeItem(null);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 9de4c78d8..4160f000e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -4,6 +4,7 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.item.tag.ItemTags;
@@ -189,7 +190,12 @@ public final class Items {
     public static Item WAND_MONSTER_SPAWNER;
     public static Item DOOR_STEEL;
     public static Item PAINTBRUSH;
-
+    public static Item JAR_BUTTERFLY_BLUE;
+    public static Item JAR_BUTTERFLY_ORANGE;
+    public static Item JAR_BUTTERFLY_PINK;
+    public static Item JAR_BUTTERFLY_SILVER;
+    public static Item STATUE_STONE;
+    
     private static boolean hasInit = false;
     public static void init(){
         if (hasInit) return;
@@ -268,30 +274,30 @@ public final class Items {
         WHEAT = (new Item("wheat", "minecraft:item/wheat", 16424)).withTags(ItemTags.COWS_FAVOURITE_ITEM);
         FOOD_BREAD = (new ItemFood("food.bread", "minecraft:item/food_bread", 16425, 5, 12, false, 8));
 
-        ARMOR_HELMET_LEATHER = (new ItemArmor("armor.helmet.leather", "minecraft:item/armor_helmet_leather", 16426, ArmorMaterial.LEATHER, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_LEATHER = (new ItemArmor("armor.chestplate.leather", "minecraft:item/armor_chestplate_leather", 16427, ArmorMaterial.LEATHER, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_LEATHER = (new ItemArmor("armor.leggings.leather", "minecraft:item/armor_leggings_leather", 16428, ArmorMaterial.LEATHER, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_LEATHER = (new ItemArmor("armor.boots.leather", "minecraft:item/armor_boots_leather", 16429, ArmorMaterial.LEATHER, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_LEATHER = (new ItemArmor("armor.helmet.leather", "minecraft:item/armor_helmet_leather", 16426, ArmorMaterial.LEATHER, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_LEATHER = (new ItemArmor("armor.chestplate.leather", "minecraft:item/armor_chestplate_leather", 16427, ArmorMaterial.LEATHER, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_LEATHER = (new ItemArmor("armor.leggings.leather", "minecraft:item/armor_leggings_leather", 16428, ArmorMaterial.LEATHER, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_LEATHER = (new ItemArmor("armor.boots.leather", "minecraft:item/armor_boots_leather", 16429, ArmorMaterial.LEATHER, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_CHAINMAIL = (new ItemArmor("armor.helmet.chainmail", "minecraft:item/armor_helmet_chainmail", 16430, ArmorMaterial.CHAINMAIL, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_CHAINMAIL = (new ItemArmor("armor.chestplate.chainmail", "minecraft:item/armor_chestplate_chainmail", 16431, ArmorMaterial.CHAINMAIL, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_CHAINMAIL = (new ItemArmor("armor.leggings.chainmail", "minecraft:item/armor_leggings_chainmail", 16432, ArmorMaterial.CHAINMAIL, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_CHAINMAIL = (new ItemArmor("armor.boots.chainmail", "minecraft:item/armor_boots_chainmail", 16433, ArmorMaterial.CHAINMAIL, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_CHAINMAIL = (new ItemArmor("armor.helmet.chainmail", "minecraft:item/armor_helmet_chainmail", 16430, ArmorMaterial.CHAINMAIL, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_CHAINMAIL = (new ItemArmor("armor.chestplate.chainmail", "minecraft:item/armor_chestplate_chainmail", 16431, ArmorMaterial.CHAINMAIL, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_CHAINMAIL = (new ItemArmor("armor.leggings.chainmail", "minecraft:item/armor_leggings_chainmail", 16432, ArmorMaterial.CHAINMAIL, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_CHAINMAIL = (new ItemArmor("armor.boots.chainmail", "minecraft:item/armor_boots_chainmail", 16433, ArmorMaterial.CHAINMAIL, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_IRON = (new ItemArmor("armor.helmet.iron", "minecraft:item/armor_helmet_iron", 16434, ArmorMaterial.IRON, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_IRON = (new ItemArmor("armor.chestplate.iron", "minecraft:item/armor_chestplate_iron", 16435, ArmorMaterial.IRON, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_IRON = (new ItemArmor("armor.leggings.iron", "minecraft:item/armor_leggings_iron", 16436, ArmorMaterial.IRON, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_IRON = (new ItemArmor("armor.boots.iron", "minecraft:item/armor_boots_iron", 16437, ArmorMaterial.IRON, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_IRON = (new ItemArmor("armor.helmet.iron", "minecraft:item/armor_helmet_iron", 16434, ArmorMaterial.IRON, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_IRON = (new ItemArmor("armor.chestplate.iron", "minecraft:item/armor_chestplate_iron", 16435, ArmorMaterial.IRON, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_IRON = (new ItemArmor("armor.leggings.iron", "minecraft:item/armor_leggings_iron", 16436, ArmorMaterial.IRON, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_IRON = (new ItemArmor("armor.boots.iron", "minecraft:item/armor_boots_iron", 16437, ArmorMaterial.IRON, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_DIAMOND = (new ItemArmor("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_DIAMOND = (new ItemArmor("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_DIAMOND = (new ItemArmor("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_DIAMOND = (new ItemArmor("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_GOLD = (new ItemArmor("armor.helmet.gold", "minecraft:item/armor_helmet_gold", 16442, ArmorMaterial.GOLD, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_GOLD = (new ItemArmor("armor.chestplate.gold", "minecraft:item/armor_chestplate_gold", 16443, ArmorMaterial.GOLD, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_GOLD = (new ItemArmor("armor.leggings.gold", "minecraft:item/armor_leggings_gold", 16444, ArmorMaterial.GOLD, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_GOLD = (new ItemArmor("armor.boots.gold", "minecraft:item/armor_boots_gold", 16445, ArmorMaterial.GOLD, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_GOLD = (new ItemArmor("armor.helmet.gold", "minecraft:item/armor_helmet_gold", 16442, ArmorMaterial.GOLD, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_GOLD = (new ItemArmor("armor.chestplate.gold", "minecraft:item/armor_chestplate_gold", 16443, ArmorMaterial.GOLD, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_GOLD = (new ItemArmor("armor.leggings.gold", "minecraft:item/armor_leggings_gold", 16444, ArmorMaterial.GOLD, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_GOLD = (new ItemArmor("armor.boots.gold", "minecraft:item/armor_boots_gold", 16445, ArmorMaterial.GOLD, HumanArmorShape.BOOTS));
         FLINT = (new Item("flint", "minecraft:item/flint", 16446));
         FOOD_PORKCHOP_RAW = (new ItemFood("food.porkchop.raw", "minecraft:item/food_porkchop_raw", 16447, 3, 16, true, 4));
         FOOD_PORKCHOP_COOKED = (new ItemFood("food.porkchop.cooked", "minecraft:item/food_porkchop_cooked", 16448, 8, 16, true, 4));
@@ -347,10 +353,10 @@ public final class Items {
         RECORD_WAIT = (new ItemDiscMusic("record.wait", "minecraft:item/record_wait", 18394, "record.wait", "C418"));
         RECORD_DOG = (new ItemDiscMusic("record.dog", "minecraft:item/record_dog", 18395, "record.dog", "C418"));
         NETHERCOAL = (new Item("nethercoal", "minecraft:item/nethercoal", 16488));
-        ARMOR_HELMET_STEEL = (new ItemArmor("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, IArmorItem.PIECE_HEAD));
-        ARMOR_CHESTPLATE_STEEL = (new ItemArmor("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, IArmorItem.PIECE_CHEST));
-        ARMOR_LEGGINGS_STEEL = (new ItemArmor("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, IArmorItem.PIECE_LEGS));
-        ARMOR_BOOTS_STEEL = (new ItemArmor("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, IArmorItem.PIECE_BOOTS));
+        ARMOR_HELMET_STEEL = (new ItemArmor("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_STEEL = (new ItemArmor("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_STEEL = (new ItemArmor("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_STEEL = (new ItemArmor("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, HumanArmorShape.BOOTS));
 
         TOOL_SWORD_STEEL = (new ItemToolSword("tool.sword.steel", "minecraft:item/tool_sword_steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
         TOOL_SHOVEL_STEEL = (new ItemToolShovel("tool.shovel.steel", "minecraft:item/tool_shovel_steel", 16494, ToolMaterial.steel));
@@ -399,5 +405,10 @@ public final class Items {
         WAND_MONSTER_SPAWNER = (new ItemWandSpawner("wand.monster", "minecraft:item/wand_monster", 16536)).setMaxStackSize(1);
         DOOR_STEEL = (new ItemDoor("door.steel", "minecraft:item/door_steel", 16537, Blocks.DOOR_STEEL_BOTTOM, Blocks.DOOR_STEEL_TOP));
         PAINTBRUSH = new ItemPaintBrush("paintbrush", "minecraft:item/paintbrush", 16538);
+        JAR_BUTTERFLY_BLUE = new ItemPlaceable("jar.butterfly.blue", "minecraft:item/jar_butterfly_blue", 16539, Blocks.JAR_BUTTERFLY_BLUE);
+        JAR_BUTTERFLY_ORANGE = new ItemPlaceable("jar.butterfly.orange", "minecraft:item/jar_butterfly_orange", 16540, Blocks.JAR_BUTTERFLY_ORANGE);
+        JAR_BUTTERFLY_PINK = new ItemPlaceable("jar.butterfly.pink", "minecraft:item/jar_butterfly_pink", 16541, Blocks.JAR_BUTTERFLY_PINK);
+        JAR_BUTTERFLY_SILVER = new ItemPlaceable("jar.butterfly.silver", "minecraft:item/jar_butterfly_silver", 16542, Blocks.JAR_BUTTERFLY_SILVER);
+        STATUE_STONE = new ItemStatue("statue.stone", "minecraft:item/statue_stone", 16543, Blocks.STATUE_STONE_LOWER, Blocks.STATUE_STONE_UPPER);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
index c953a03c7..3da062e97 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.net.command;
 
+import org.jetbrains.annotations.Nullable;
+
 public class TextFormatting {
 	public static final TextFormatting[] FORMATTINGS = new TextFormatting[22];
 	
@@ -26,6 +28,8 @@ public class TextFormatting {
     public static final TextFormatting ITALIC = new TextFormatting(20).setNames("Italic");
     public static final TextFormatting RESET = new TextFormatting(21).setNames("Reset");
 
+	public static final char SPECIAL_CHAR = '\247';
+
 	public final int id;
 	public final char code;
 	private String[] names;
@@ -35,6 +39,15 @@ public class TextFormatting {
 		this.id = id;
 		this.code = "0123456789abcdefklmnor".charAt(id);
 	}
+
+	public static @Nullable TextFormatting fromChar(final char c) {
+        for (TextFormatting formatting : FORMATTINGS) {
+            if (formatting.code == c) {
+                return formatting;
+            }
+        }
+		return null;
+	}
 	
 	public TextFormatting setNames(String... names) {
 		this.names = names;
@@ -82,7 +95,7 @@ public class TextFormatting {
 	
 	@Override
 	public String toString() {
-		return "\247" + code;
+		return "" + SPECIAL_CHAR + code;
 	}
 	
 	public static TextFormatting get(int id) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
index 2b21364c5..4291996c8 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
@@ -47,6 +47,7 @@ public class ArgumentTypeParticleId implements ArgumentType<String> {
         particleIds.add("fireflyGreen");
         particleIds.add("fireflyRed");
         particleIds.add("splash");
+        particleIds.add("ashmote");
     }
 
     private static final List<String> EXAMPLES = Arrays.asList("fireflyGreen", "explode", "soulflame");
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index 34710a3f3..8fef34a37 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -397,9 +398,9 @@ public class ContainerInventory
         }
     }
 
-    public ItemStack armorItemInSlot(int i)
+    public ItemStack armorItemInSlot(IArmorShape shape)
     {
-        return armorInventory[i];
+        return armorInventory[shape.getSlotIndex()];
     }
 
     public int getTotalArmourPoints() {
@@ -419,52 +420,6 @@ public class ContainerInventory
     	return (int) (20 * (armorDurability / maxDurability));
     }
 
-    public float getTotalProtectionAmount(DamageType damageType) {
-    	float protectionPercentage = 0.0f;
-
-        for (ItemStack itemStack : armorInventory) {
-            if (itemStack != null && itemStack.getItem() instanceof IArmorItem) {
-                IArmorItem armor = (IArmorItem) itemStack.getItem();
-                ArmorMaterial material = armor.getArmorMaterial();
-                if (material != null) {
-                    protectionPercentage += material.getProtection(damageType) * armor.getArmorPieceProtectionPercentage();
-                }
-            }
-        }
-    	
-    	return protectionPercentage;
-    }
-
-    public void damageArmor(int damage)
-    {
-        for(int j = 0; j < armorInventory.length; j++)
-        {
-            if(armorInventory[j] == null || !(armorInventory[j].getItem() instanceof IArmorItem))
-            {
-                continue;
-            }
-            armorInventory[j].damageItem(damage, player);
-            if(armorInventory[j].stackSize <= 0)
-            {
-                armorInventory[j] = null;
-            }
-        }
-
-    }
-
-    public void damageArmor(int damage, int armorSlot)
-    {
-        if(armorInventory[armorSlot] == null)
-        {
-            return;
-        }
-        armorInventory[armorSlot].damageItem(damage, player);
-        if(armorInventory[armorSlot].stackSize <= 0)
-        {
-            armorInventory[armorSlot] = null;
-        }
-    }
-
     public void dropAllItems()
     {
         for(int i = 0; i < mainInventory.length; i++)
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 8d57d074a..706d6c50c 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -7,6 +7,8 @@ import net.minecraft.core.InventoryAction;
 import net.minecraft.core.Global;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -382,17 +384,17 @@ public abstract class MenuAbstract
 		}
 		
 		Item itemInSlot = stackInSlot.getItem();
-		IArmorItem armorItem;
+		IArmorItem<HumanArmorShape> armorItem;
 		
 		// Check if item is armor
-		if(itemInSlot instanceof IArmorItem) {
-			armorItem = (IArmorItem) itemInSlot;
-		}else {
+		if(itemInSlot instanceof IArmorItem && ((IArmorItem<?>) itemInSlot).getArmorShape() instanceof HumanArmorShape) {
+			armorItem = (IArmorItem<HumanArmorShape>) itemInSlot;
+		} else {
 			return;
 		}
-		
-		int armorSlot = 3 - armorItem.getArmorPiece();
-		
+
+		HumanArmorShape armorShape = armorItem.getArmorShape();
+
 		// Take new armor
 		ItemStack newArmor = stackInSlot;
 		slot.set(null);
@@ -400,9 +402,9 @@ public abstract class MenuAbstract
 		slot.setChanged();
 		
 		// Equip new armor
-		ItemStack oldArmor = player.inventory.armorInventory[armorSlot];
-		player.inventory.armorInventory[armorSlot] = newArmor;
-		
+		ItemStack oldArmor = player.getItemInArmorSlot(armorShape);
+		player.setItemInArmorSlot(armorShape, newArmor);
+
 		// Put old armor in slot, or drop if not possible
 		mergeItems(oldArmor, slot.index);
 		storeOrDropItem(player, oldArmor);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index 320838c4b..a69475996 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.menu;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
@@ -39,9 +40,8 @@ public class MenuInventory extends MenuAbstract {
 			}
 		}
 		
-		for (int i = 0; i < 4; i++) {
-			int armorType = IArmorItem.PIECE_HEAD - i;
-			addSlot(new SlotArmor(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, armorType));
+		for (int i = 0; i < HumanArmorShape.values().length; i++) {
+			addSlot(new SlotArmor(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, HumanArmorShape.values()[HumanArmorShape.values().length - (i + 1)]));
 		}
 		
 		for (int i = 0; i < 3; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
index 140076801..f1b5492e3 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
@@ -2,6 +2,7 @@ package net.minecraft.core.player.inventory.slot;
 
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
@@ -23,14 +24,14 @@ public class SlotArmor extends Slot
         "minecraft:item/armor_helmet_outline"
     };
 
-    final int armorType;
+    final HumanArmorShape armorShape;
     final MenuInventory menu;
 
-    public SlotArmor(MenuInventory menu, Container container, int index, int x, int y, int armorType)
+    public SlotArmor(MenuInventory menu, Container container, int index, int x, int y, HumanArmorShape armorShape)
     {
         super(container, index, x, y);
         this.menu = menu;
-        this.armorType = armorType;
+        this.armorShape = armorShape;
     }
 
     @Override
@@ -44,9 +45,9 @@ public class SlotArmor extends Slot
     {
         if(itemstack.getItem() instanceof IArmorItem)
         {
-            return ((IArmorItem)itemstack.getItem()).getArmorPiece() == armorType;
+            return ((IArmorItem<?>) itemstack.getItem()).getArmorShape() == this.armorShape;
         }
-        return armorType == IArmorItem.PIECE_HEAD;
+        return this.armorShape == HumanArmorShape.HEAD;
     }
     
     @Override
@@ -98,6 +99,6 @@ public class SlotArmor extends Slot
     @Override
 	public String getItemIcon()
     {
-        return armorOutlines[armorType];
+        return armorOutlines[this.armorShape.getSlotIndex()];
     }
 }
